# 2016.11.08 20:41:54 CET
# Embedded file name: ./FastSearch.py
from Screens.ChoiceBox import ChoiceBox
from Screens.InputBox import InputBox
from Screens.Screen import Screen
from Components.ActionMap import ActionMap
from Components.Label import Label
from Components.Sources.StaticText import StaticText
from Components.config import config, configfile, ConfigSubsection, ConfigInteger
from Screens.MessageBox import MessageBox
from Components.ServiceEventTracker import ServiceEventTracker
from enigma import iPlayableService
from Components.MenuList import MenuList
from enigma import eTimer, ePoint, eSize, eLabel, gFont, eConsoleAppContainer, iServiceInformation, eServiceReference, addFont, getDesktop
from skin import parseColor, parseFont
import time
import subprocess, fcntl, os
from enigma import eServiceReference, eEPGCache, eServiceCenter, eRCInput, eTimer, eDVBDB, iPlayableService, iServiceInformation, getPrevAsciiCode
from ServiceReference import ServiceReference
from Components.TuneTest import Tuner
from enigma import eDVBResourceManager, eDVBFrontendParametersSatellite, eDVBFrontendParameters
import fcntl
from struct import Struct
import sys
import os
import datetime
from ioctl import _IO, _IOR, _IOW
import select
import time
from CRC import dvbcrc
from Descriptors import parseDescriptor
from operator import itemgetter, attrgetter
i1 = 'FastSearch v1.3 by freebox, mod by tequila'
i2 = 'Program do szybkiego pobierania listy kana\xc5\x82\xc3\xb3w.\nAutomatycznie tworzone s\xc4\x85 bukiety dla kana\xc5\x82\xc3\xb3w TV i Radia,\ndo nazwy dodawana jest data oraz godzina utworzenia np:\nNC+ 01012011 1200\nKolejno\xc5\x9b\xc4\x87 kana\xc5\x82\xc3\xb3w ustalna jest weg\xc5\x82ug numeracji operatora.\nNumeracja kana\xc5\x82\xc3\xb3w zgodna z numeracj\xc4\x85 operatora (opcja).\n\n'
dmx_pes_filter_params_t = Struct('HLLLL')
DMX_START = _IO('o', 41)
DMX_STOP = _IO('o', 42)
DMX_SET_PES_FILTER = _IOW('o', 44, dmx_pes_filter_params_t)
DMX_SET_BUFFER_SIZE = _IO('o', 45)
DMX_OUT_DECODER = 0
DMX_OUT_TAP = 1
DMX_OUT_TS_TAP = 2
DMX_IN_FRONTEND = 0
DMX_IN_DVR = 1
DMX_PES_OTHER = 20
DMX_CHECK_CRC = 1
DMX_ONESHOT = 2
DMX_IMMEDIATE_START = 4
DMX_KERNEL_CLIENT = 32768
DVB_SI_PAT_PID = 0
DVB_SI_CAT_PID = 1
DVB_SI_SDT_PID = 17
DVB_SI_BAT_PID = 17
DVB_SI_NIT_PID = 16
DVB_SI_PAT_TAB_ID = [0]
DVB_SI_CAT_TAB_ID = [1]
DVB_SI_PMT_TAB_ID = [2]
DVB_SI_NIT_TAB_ID = [64, 65]
DVB_SI_BAT_TAB_ID = [74]
DVB_SI_SDT_TAB_ID = range(66, 70)
DVB_SI_EIT_TAB_ID = range(78, 111)
DVB_SI_ECM_TAB_ID = [129, 129]
DVB_SI_EMMSR_TAB_ID = [130]
DVB_SI_EMMSH_TAB_ID = [132]

def find_s_sid(s, tab):
    l = len(tab)
    for poz in range(l):
        if tab[poz][1].find(s) == 0:
            return poz

    return None


def find_s_sid_tid(s, t, tab):
    l = len(tab)
    for poz in range(l):
        if tab[poz][1].find(s) == 0 and tab[poz][1].find(t) == 14:
            return poz

    return None


def find_t_tid(s, tab):
    l = len(tab)
    for poz in range(l):
        if tab[poz][0].find(s) == 9:
            return poz

    return None


def find_t(s, tab):
    l = len(tab)
    for poz in range(l):
        if tab[poz][0].find(s) == 0:
            return poz

    return None


def save_lamedb(name, tab_t, tab_s):
    print 'Save lamedb'
    f = open(name, 'w')
    f.write('eDVB services /4/\n')
    f.write('transponders\n')
    for poz in tab_t:
        f.write(poz[0] + '\n')
        f.write('\t' + poz[1] + '\n')
        f.write('/\n')

    f.write('end\n')
    f.write('services\n')
    for poz in tab_s:
        f.write(poz[0] + '\n')
        f.write(poz[1] + '\n')
        f.write(poz[2] + '\n')

    f.write('end\n')
    f.close()


def load_lamedb(name, tab_t, tab_s):
    print 'Load lamedb'
    f = open(name, 'r')
    l = f.readlines()
    f.close()
    tab_transponders = False
    tab_services = False
    poz = 0
    len_ = len(l) - 1
    while True:
        if tab_transponders is True:
            if l[poz].find('end') == 0:
                tab_transponders = False
                print 'Stop tablica transponders ', poz
            else:
                l1 = l[poz].strip()
                poz += 1
                l2 = l[poz].strip()
                poz += 1
                l3 = l[poz]
                tab_t.append([l1, l2])
        if tab_services is True:
            if l[poz].find('end') == 0:
                tab_services = False
                print 'Stop tablica services ', poz
            else:
                l1 = l[poz].strip()
                poz += 1
                l2 = l[poz].strip()
                poz += 1
                l3 = l[poz].strip()
                tab_s.append([l1, l2, l3])
        if l[poz].find('transponders') == 0:
            print 'Start tablica transponders ', poz
            tab_transponders = True
        if l[poz].find('services') == 0:
            print 'Start tablica services ', poz
            tab_services = True
        poz += 1
        if poz >= len_:
            break


def doIoctl(fd, op, arg = 0, muttable = 0):
    try:
        if muttable == 0:
            return fcntl.ioctl(fd, op, arg)
        return fcntl.ioctl(fd, op, arg, muttable)
    except IOError:
        e = sys.exc_info()[1]
        print 'ioctl op (0x%08x) error(%d): %s' % (op, e.errno, e.strerror)


def getNIT(timeout = 1, num = 1):
    try:
        fd = os.open('/dev/dvb/adapter0/demux0', os.O_RDWR | os.O_NONBLOCK)
    except IOError:
        e = sys.exc_info()[1]
        print 'I/O error(%d): %s' % (e.errno, e.strerror)
        os.close(fd)
        return (1, 0, 0)

    print 'DMX Open'
    DMX_BUFFER_SIZE = 262144
    doIoctl(fd, DMX_SET_BUFFER_SIZE, DMX_BUFFER_SIZE)
    pes = dmx_pes_filter_params_t.pack(DVB_SI_NIT_PID, DMX_IN_FRONTEND, DMX_OUT_TAP, DMX_PES_OTHER, DMX_IMMEDIATE_START)
    doIoctl(fd, DMX_SET_PES_FILTER, pes)
    timeout_, out, num = getPesDataNIT(fd, DVB_SI_NIT_TAB_ID, timeout, num)
    if timeout_ == 1:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close - timeout'
        return (2, out, num)
    else:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close'
        return (0, out, num)


def getBAT(timeout = 1, num = 1):
    try:
        fd = os.open('/dev/dvb/adapter0/demux0', os.O_RDWR | os.O_NONBLOCK)
    except IOError:
        e = sys.exc_info()[1]
        print 'I/O error(%d): %s' % (e.errno, e.strerror)
        os.close(fd)
        return (1, 0, 0)

    print 'DMX Open'
    DMX_BUFFER_SIZE = 262144
    doIoctl(fd, DMX_SET_BUFFER_SIZE, DMX_BUFFER_SIZE)
    pes = dmx_pes_filter_params_t.pack(DVB_SI_BAT_PID, DMX_IN_FRONTEND, DMX_OUT_TAP, DMX_PES_OTHER, DMX_IMMEDIATE_START)
    doIoctl(fd, DMX_SET_PES_FILTER, pes)
    timeout_, out, num = getPesDataBAT(fd, DVB_SI_BAT_TAB_ID, timeout, num)
    if timeout_ == 1:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close - timeout'
        return (2, out, num)
    else:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close'
        return (0, out, num)


def getPAT(timeout = 1):
    try:
        fd = os.open('/dev/dvb/adapter0/demux0', os.O_RDWR | os.O_NONBLOCK)
    except IOError:
        e = sys.exc_info()[1]
        print 'I/O error(%d): %s' % (e.errno, e.strerror)
        os.close(fd)
        return (1, 0)

    print 'DMX Open'
    DMX_BUFFER_SIZE = 262144
    doIoctl(fd, DMX_SET_BUFFER_SIZE, DMX_BUFFER_SIZE)
    pes = dmx_pes_filter_params_t.pack(DVB_SI_PAT_PID, DMX_IN_FRONTEND, DMX_OUT_TAP, DMX_PES_OTHER, DMX_IMMEDIATE_START)
    doIoctl(fd, DMX_SET_PES_FILTER, pes)
    timeout_, d1_, d2_ = getPesDataPAT(fd, DVB_SI_PAT_TAB_ID, timeout)
    if timeout_ == 1:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close - timeout'
        return (2, 0)
    else:
        out = parseTablePAT(DVB_SI_PAT_TAB_ID, d1_, d2_)
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close'
        return (0, out)


def getSDT(timeout = 1, num = 1):
    try:
        fd = os.open('/dev/dvb/adapter0/demux0', os.O_RDWR | os.O_NONBLOCK)
    except IOError:
        e = sys.exc_info()[1]
        print 'I/O error(%d): %s' % (e.errno, e.strerror)
        os.close(fd)
        return (1, 0)

    print 'DMX Open'
    DMX_BUFFER_SIZE = 262144
    doIoctl(fd, DMX_SET_BUFFER_SIZE, DMX_BUFFER_SIZE)
    pes = dmx_pes_filter_params_t.pack(DVB_SI_SDT_PID, DMX_IN_FRONTEND, DMX_OUT_TAP, DMX_PES_OTHER, DMX_IMMEDIATE_START)
    doIoctl(fd, DMX_SET_PES_FILTER, pes)
    timeout_, out, num = getPesDataSDT(fd, DVB_SI_SDT_TAB_ID, timeout, num)
    if timeout_ == 1:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close - timeout'
        return (2, out, num)
    else:
        doIoctl(fd, DMX_STOP)
        os.close(fd)
        print 'DMX Close'
        return (0, out, num)


def getPesDataNIT(fd, tabId, t_timeout = 1, num = 1):
    acceptTables = {64: 'ACTUAL',
     65: 'OTHER'}
    sections = {}
    latest_versions = {}
    last_section_numbers = {}
    missing_sections_count = {}
    l = []
    t_start = time.time()
    num_ = 0
    while True:
        if True:
            t_stop = time.time()
            tt = t_stop - t_start
            if tt > t_timeout:
                return (1, l, num_)
            while True:
                try:
                    b = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            if not ord(b) == 0:
                continue
            while True:
                try:
                    b0 = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            table_id = ord(b0)
            if table_id not in acceptTables.keys():
                continue
            while True:
                try:
                    b1 = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            if not ord(b1) & 128 == 128:
                continue
            while True:
                try:
                    e = b0 + b1 + os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            section_length = (ord(e[1]) << 8) + ord(e[2]) & 4095
            sl = 0
            while True:
                while True:
                    try:
                        b = os.read(fd, 1)
                        break
                    except OSError:
                        t_stop = time.time()
                        tt = t_stop - t_start
                        if tt > t_timeout:
                            return (1, l, num_)

                e += b
                sl += 1
                if sl == section_length:
                    break

            network_id = (ord(e[3]) << 8) + ord(e[4])
            version = ord(e[5]) & 62
            current_next = ord(e[5]) & 1
            section_number = ord(e[6])
            last_section_number = ord(e[7])
            if section_length != len(e) - 3:
                print 'section_length:', section_length
                print '!!! error !!! read len:', len(e) - 3
            index = (table_id, current_next, network_id)
            crcpass = False
            if version != latest_versions.get(index, -1):
                if not dvbcrc(e[:3 + section_length]):
                    continue
                else:
                    crcpass = True
                latest_versions[index] = version
                sections[index] = [None] * (last_section_number + 1)
                missing_sections_count[index] = last_section_number + 1
            if sections[index][section_number] == None:
                if crcpass or dvbcrc(e[:3 + section_length]):
                    sections[index][section_number] = (e, section_length)
                    missing_sections_count[index] -= 1
                    if missing_sections_count[index] == 0:
                        l.append(parseTableNIT(index, sections[index]))
                        num_ = num_ + 1
                        t_stop = time.time()
                        tt = t_stop - t_start
                        print '>>', num_, ' tim:', tt
                        if num_ == num:
                            break

    return (0, l, num_)


def getPesDataBAT(fd, tabId, t_timeout = 1, num = 1):
    sections = {}
    latest_versions = {}
    last_section_numbers = {}
    missing_sections_count = {}
    l = []
    t_start = time.time()
    num_ = 0
    while True:
        if True:
            t_stop = time.time()
            tt = t_stop - t_start
            if tt > t_timeout:
                return (1, l, num_)
            while True:
                try:
                    b = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            if not ord(b) == 0:
                continue
            while True:
                try:
                    b0 = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            table_id = ord(b0)
            if table_id != 74 and table_id != 66 and table_id != 70:
                continue
            while True:
                try:
                    b1 = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            if not ord(b1) & 128 == 128:
                continue
            while True:
                try:
                    e = b0 + b1 + os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            section_length = (ord(e[1]) << 8) + ord(e[2]) & 4095
            sl = 0
            while True:
                while True:
                    try:
                        b = os.read(fd, 1)
                        break
                    except OSError:
                        t_stop = time.time()
                        tt = t_stop - t_start
                        if tt > t_timeout:
                            return (1, l, num_)

                e += b
                sl += 1
                if sl == section_length:
                    break

            if section_length != len(e) - 3:
                print 'section_length:', section_length
                print '!!! error !!! read len:', len(e) - 3
            if table_id == 66 or table_id == 70:
                continue
            network_id = (ord(e[3]) << 8) + ord(e[4])
            version = ord(e[5]) & 62
            current_next = ord(e[5]) & 1
            section_number = ord(e[6])
            last_section_number = ord(e[7])
            index = (table_id, current_next, network_id)
            crcpass = False
            if version != latest_versions.get(index, -1):
                if not dvbcrc(e[:3 + section_length]):
                    continue
                else:
                    crcpass = True
                latest_versions[index] = version
                sections[index] = [None] * (last_section_number + 1)
                missing_sections_count[index] = last_section_number + 1
            if sections[index][section_number] == None:
                if crcpass or dvbcrc(e[:3 + section_length]):
                    sections[index][section_number] = (e, section_length)
                    missing_sections_count[index] -= 1
                    if missing_sections_count[index] == 0:
                        l.append(parseTableBAT(index, sections[index]))
                        num_ = num_ + 1
                        t_stop = time.time()
                        tt = t_stop - t_start
                        print '>>', num_, ' tim:', tt
                        if num_ == num:
                            break

    return (0, l, num_)


def getPesDataSDT(fd, tabId, t_timeout = 1, num = 1):
    acceptTables = {66: 'ACTUAL',
     70: 'OTHER'}
    sections = {}
    latest_versions = {}
    last_section_numbers = {}
    missing_sections_count = {}
    num_ = 0
    l = []
    t_start = time.time()
    while True:
        if True:
            t_stop = time.time()
            tt = t_stop - t_start
            if tt > t_timeout:
                return (1, l, num_)
            while True:
                try:
                    b = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            if not ord(b) == 0:
                continue
            while True:
                try:
                    b0 = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            table_id = ord(b0)
            if table_id != 74 and table_id != 66 and table_id != 70:
                continue
            while True:
                try:
                    b1 = os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            if not ord(b1) & 128 == 128:
                continue
            while True:
                try:
                    e = b0 + b1 + os.read(fd, 1)
                    break
                except OSError:
                    t_stop = time.time()
                    tt = t_stop - t_start
                    if tt > t_timeout:
                        return (1, l, num_)

            section_length = (ord(e[1]) << 8) + ord(e[2]) & 4095
            sl = 0
            while True:
                while True:
                    try:
                        b = os.read(fd, 1)
                        break
                    except OSError:
                        t_stop = time.time()
                        tt = t_stop - t_start
                        if tt > t_timeout:
                            return (1, l, num_)

                e += b
                sl += 1
                if sl == section_length:
                    break

            if section_length != len(e) - 3:
                print 'section_length:', section_length
                print '!!! error !!! read len:', len(e) - 3
            if table_id == 74:
                continue
            version = ord(e[5]) & 62
            current_next = ord(e[5]) & 1
            section_number = ord(e[6])
            last_section_number = ord(e[7])
            transport_stream_id = (ord(e[3]) << 8) + ord(e[4])
            original_network_id = (ord(e[8]) << 8) + ord(e[9])
            index = (table_id,
             current_next,
             transport_stream_id,
             original_network_id)
            crcpass = False
            if version != latest_versions.get(index, -1):
                if not dvbcrc(e[:3 + section_length]):
                    continue
                else:
                    crcpass = True
                latest_versions[index] = version
                sections[index] = [None] * (last_section_number + 1)
                missing_sections_count[index] = last_section_number + 1
            if sections[index][section_number] == None:
                if crcpass or dvbcrc(e[:3 + section_length]):
                    sections[index][section_number] = (e, section_length)
                    missing_sections_count[index] -= 1
                    if missing_sections_count[index] == 0:
                        l.append(parseTableSDT(index, sections[index]))
                        num_ = num_ + 1
                        t_stop = time.time()
                        tt = t_stop - t_start
                        print '>>', num_, ' tim:', tt
                        if num_ == num:
                            break

    return (0, l, num_)


def getPesDataPAT(fd, tabId, t_timeout):
    sections = [[], []]
    latest_versions = [-1, -1]
    last_section_numbers = [0, 0]
    missing_sections_count = [0, 0]
    t_start = time.time()
    while True:
        try:
            b = os.read(fd, 1)
            if not ord(b) == 0:
                continue
            b0 = os.read(fd, 1)
            table_id = ord(b0)
            if ord(b0) not in tabId:
                continue
            b1 = os.read(fd, 1)
            if not ord(b1) & 128 == 128:
                continue
            e = b0 + b1 + os.read(fd, 1)
            section_length = (ord(e[1]) << 8) + ord(e[2]) & 4095
            e += os.read(fd, section_length)
            version = ord(e[5]) & 62
            current_next = ord(e[5]) & 1
            section_number = ord(e[6])
            last_section_number = ord(e[7])
            crcpass = False
            if version != latest_versions[current_next]:
                if not dvbcrc(e[:3 + section_length]):
                    continue
                else:
                    crcpass = True
                latest_versions[current_next] = version
                sections[current_next] = [None] * (last_section_number + 1)
                missing_sections_count[current_next] = last_section_number + 1
            if sections[current_next][section_number] == None:
                if crcpass or dvbcrc(e[:3 + section_length]):
                    sections[current_next][section_number] = (e, section_length)
                    missing_sections_count[current_next] -= 1
                    if missing_sections_count[current_next] == 0:
                        break
        except OSError:
            t_stop = time.time()
            tt = t_stop - t_start
            if tt > t_timeout:
                return (1, 0, 0)

    return (0, current_next, sections[current_next])


def parseTableSDT(index, sections):
    table_id, current_next, transport_stream_id, original_network_id = index
    acceptTables = {66: 'ACTUAL',
     70: 'OTHER'}
    msg = {'table_type': 'SDT',
     'table_id': table_id,
     'actual_other': acceptTables[table_id],
     'current': current_next,
     'transport_stream_id': transport_stream_id,
     'original_network_id': original_network_id}
    services = {}
    for data, section_length in sections:
        i = 11
        while i < section_length + 3 - 4:
            service_id = (ord(data[i]) << 8) + ord(data[i + 1])
            service = {}
            lo = ord(data[i + 2])
            service['eit_schedule'] = lo & 2
            service['eit_present_following'] = lo & 1
            hi = ord(data[i + 3])
            service['running_status'] = hi >> 5
            service['free_CA_mode'] = hi & 16
            descriptors_length = (hi << 8) + ord(data[i + 4]) & 4095
            i = i + 5
            descriptors_end = i + descriptors_length
            service['descriptors'] = []
            while i < descriptors_end:
                descriptor, i = parseDescriptor(i, data)
                service['descriptors'].append(descriptor)

            services[service_id] = service

    msg['services'] = services
    return msg


def parseTablePAT(table_id, current_next, sections):
    msg = {'table_type': 'PAT',
     'table_id': table_id,
     'current': current_next}
    streams = {}
    for data, section_length in sections:
        transportstream_id = (ord(data[3]) << 8) + ord(data[4])
        try:
            services = streams[transportstream_id]
        except KeyError:
            services = {}

        lo = ord(data[5])
        i = 8
        section_end = section_length + 3 - 4
        while i < section_end:
            service_id = (ord(data[i]) << 8) + ord(data[i + 1])
            pid = (ord(data[i + 2]) << 8) + ord(data[i + 3])
            pid = pid & 8191
            if service_id == 0:
                msg['NIT_PID'] = pid
            else:
                services[service_id] = pid
            i += 4

        streams[transportstream_id] = services

    msg['transport_streams'] = streams
    return msg


def parseTableNIT(index, sections):
    acceptTables = {64: 'ACTUAL',
     65: 'OTHER'}
    table_id, current_next, network_id = index
    msg = {'table_type': 'NIT',
     'table_id': table_id,
     'actual_other': acceptTables[table_id],
     'current': current_next,
     'network_id': network_id}
    services = {}
    tss = []
    for data, section_length in sections:
        network_descriptors_length = (ord(data[8]) << 8) + ord(data[9]) & 4095
        i = 10
        network_descriptors_end = i + network_descriptors_length
        msg['descriptors'] = []
        while i < network_descriptors_end:
            descriptor, i = parseDescriptor(i, data)
            msg['descriptors'].append(descriptor)

        ts_loop_length = (ord(data[i]) << 8) + ord(data[i + 1]) & 4095
        i = i + 2
        ts_loop_end = i + ts_loop_length
        while i < ts_loop_end:
            ts = {}
            ts['transport_stream_id'] = (ord(data[i]) << 8) + ord(data[i + 1])
            ts['original_network_id'] = (ord(data[i + 2]) << 8) + ord(data[i + 3])
            transport_descriptors_length = (ord(data[i + 4]) << 8) + ord(data[i + 5]) & 4095
            i = i + 6
            transport_descriptors_end = i + transport_descriptors_length
            ts['descriptors'] = []
            while i < transport_descriptors_end:
                descriptor, i = parseDescriptor(i, data)
                ts['descriptors'].append(descriptor)

            tss.append(ts)

    msg['transport_streams'] = tss
    return msg


def parseTableBAT(index, sections):
    acceptTables = {74: 'ACTUAL'}
    table_id, current_next, network_id = index
    msg = {'table_type': 'BAT',
     'table_id': table_id,
     'actual_other': acceptTables[table_id],
     'current': current_next,
     'network_id': network_id}
    services = {}
    tss = []
    for data, section_length in sections:
        network_descriptors_length = (ord(data[8]) << 8) + ord(data[9]) & 4095
        i = 10
        network_descriptors_end = i + network_descriptors_length
        msg['descriptors'] = []
        while i < network_descriptors_end:
            descriptor, i = parseDescriptor(i, data)
            msg['descriptors'].append(descriptor)

        ts_loop_length = (ord(data[i]) << 8) + ord(data[i + 1]) & 4095
        i = i + 2
        ts_loop_end = i + ts_loop_length
        while i < ts_loop_end:
            ts = {}
            ts['transport_stream_id'] = (ord(data[i]) << 8) + ord(data[i + 1])
            ts['original_network_id'] = (ord(data[i + 2]) << 8) + ord(data[i + 3])
            transport_descriptors_length = (ord(data[i + 4]) << 8) + ord(data[i + 5]) & 4095
            i = i + 6
            transport_descriptors_end = i + transport_descriptors_length
            ts['descriptors'] = []
            while i < transport_descriptors_end:
                descriptor, i = parseDescriptor(i, data)
                ts['descriptors'].append(descriptor)

            tss.append(ts)

    msg['transport_streams'] = tss
    return msg


oper_order = True

def set_order(order):
    global oper_order
    oper_order = order


def fill_gaps(pos, id, file):
    empty_service = '#SERVICE 1:832:D:0:0:0:0:0:0:0:\n'
    while pos < id:
        file.write(empty_service)
        pos = pos + 1

    return pos


def add_channel_to_bouquet(pos, id, file, st, sid, tid, nid, ns):
    global first_service
    print 'lcn: ', id, ' pos: ', pos, ' type: ', st
    if oper_order:
        pos = fill_gaps(pos, id, file)
    l = '#SERVICE 1:0:' + st + ':' + sid + ':' + tid + ':' + nid + ':' + ns + ':0:0:0:\n'
    pos = pos + 1
    if first_service == None:
        first_service = l[9:].rstrip()
    file.write(l)
    return pos


def build_bouquets(db, tv_file, radio_file):
    tv_pos = 1
    radio_pos = 1
    for i in db:
        sid = i[1][0:4]
        ns = i[1][5:13]
        tid = i[1][14:18]
        nid = i[1][19:23]
        st = i[1][24:25]
        id = int(i[0])
        if st == '1':
            tv_pos = add_channel_to_bouquet(tv_pos, id, tv_file, st, sid, tid, nid, ns)
        elif st == '2':
            radio_pos = add_channel_to_bouquet(radio_pos, id, radio_file, st, sid, tid, nid, ns)


class Cyfra(Screen):

    def __init__(self, session, frontend, zakres):
        self.frontend = frontend
        self.zakres = zakres
        self.tuner = Tuner(self.frontend)
        self.tmp_str = ''
        self.old_str = ''
        self.end = 0
        self.skin = '\n\t\t\t<screen position="center,center" size="570,500" title="NC+" >\n\t\t\t\t<widget name="memo" position="10,5" size="540,450" font="Regular;20" />\n\t\t\t\t<eLabel position="15,460" size="540,1" backgroundColor="white" />\n\t\t\t\t<widget name="info" position="15,470" size="540,30" halign="center" font="Regular;25" backgroundColor="background" transparent="1"/>\n\t\t\t</screen> '
        Screen.__init__(self, session)
        self['info'] = Label()
        self['info'].setText(i1)
        self['memo'] = Label()
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions'], {'cancel': self.Exit}, -1)
        self.timer = eTimer()
        self.timer.callback.append(self.P1)
        self.timer.start(100)

    def Exit(self):
        if self.end == 1:
            self.close()

    def P1(self):
        self.db_t = []
        self.db_s = []
        self.size_t = 0
        self.size_s = 0
        self.timer.stop()
        self.timer.callback.remove(self.P1)
        transponder = (10719, 27500, 1, 5, 0, 130, 1, 1, 0, 2)
        if self.frontend != None:
            self.tuner.tune(transponder)
            print 'Aktywacja transpondera - czekaj >>', transponder
            self.tmp_str += 'Aktywacja transpondera - czekaj\n'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P2)
            self.timer.start(5000)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak wolnego tunera\n'
            self.tmp_str += 'Koniec\n'
            print 'Aktywacja transpondera - brak wolnego tunera'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        return

    def P2(self):
        self.timer.stop()
        self.timer.callback.remove(self.P2)
        status = {}
        self.frontend.getFrontendStatus(status)
        if status:
            if status.get('tuner_locked') != 1:
                self.tmp_str += 'Aktywacja transpondera - niepoprawna\n'
                self.tmp_str += 'Koniec\n'
                self['memo'].setText(self.tmp_str)
                print 'Aktywacja transpondera - niepoprawna'
                self.end = 1
                return
            self.tmp_str += 'Aktywacja transpondera - poprawna\n'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj\n'
            print 'Aktywacja transpondera poprawna'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P3)
            self.timer.start(100)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak statusu\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            print 'Aktywacja transpondera - brak statusu'
            self.end = 1
            return

    def P3(self):
        self.timer.stop()
        self.timer.callback.remove(self.P3)
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj'
        print 'NIT'
        e, nit, num = getNIT(15, 200)
        print 'NIT:', num
        if num == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        for n in range(num):
            nid = nit[n]['network_id']
            for i in nit[n]['transport_streams']:
                tid = i['transport_stream_id']
                for ii in i['descriptors']:
                    if ii[0] == 67:
                        pos = ii[1]['params']['orbital_position']
                        if pos == 0:
                            print '!!! UWAGA !!! orbital_position=0 tid:', tid, ' ustawiam domyslnie 130'
                            pos = 130
                        l1 = '%0.4x0000:%0.4x:%0.4x' % (pos, tid, nid)
                        if ii[1]['params']['polarization'] == 'V':
                            pol = 1
                        else:
                            pol = 0
                        fec = ii[1]['params']['fec_inner']
                        if fec == 'None':
                            fec = 0
                        elif fec == '1/2':
                            fec = 1
                        elif fec == '2/3':
                            fec = 2
                        elif fec == '3/4':
                            fec = 3
                        elif fec == '5/6':
                            fec = 4
                        elif fec == '7/8':
                            fec = 5
                        elif fec == '8/9':
                            fec = 6
                        elif fec == '3/5':
                            fec = 7
                        elif fec == '4/5':
                            fec = 8
                        elif fec == '9/10':
                            fec = 9
                        else:
                            fec = 0
                        if fec == 0:
                            print '!!! UWAGA !!! fec=0 TID:', tid
                        if ii[1]['params']['modulation_type'] == '8PSK':
                            l2 = 's %s:%s:%s:%s:%s:0:0:1:2:%s:2' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos,
                             ii[1]['params']['rolloff'])
                        else:
                            l2 = 's %s:%s:%s:%s:%s:0:0' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos)
                        self.db_t.append([l1, l2])
                        self.size_t += 1

        if self.size_t == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne\n'
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne'
        self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj\n'
        print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P4)
        self.timer.start(100)

    def P4(self):
        self.timer.stop()
        self.timer.callback.remove(self.P4)
        temp_maping = {}
        print 'BAT'
        e, bat, num = getBAT(45, 400)
        print 'BAT:', num
        if num == 0:
            print 'BAT pusty'
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w'
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        else:
            for n in range(num):
                bid = bat[n]['network_id']
                if bid == 49188 and self.zakres == 1 or bid == 49186 and self.zakres == 2:
                    for i in bat[n]['transport_streams']:
                        tid = i['transport_stream_id']
                        for ii in i['descriptors']:
                            if ii[0] == 65:
                                for iii in ii[1]['services']:
                                    s = iii['service_type']
                                    if s == ('digital television service',):
                                        s_t = 1
                                    elif s == ('digital radio sound service',):
                                        s_t = 2
                                    else:
                                        s_t = 3
                                    sid = iii['service_id']
                                    ss = '%0.4x' % tid
                                    pt = find_t_tid(ss, self.db_t)
                                    if pt != None:
                                        s = '%0.4x:%s:%d:0' % (sid, self.db_t[pt][0], s_t)
                                        self.db_s.append([10000,
                                         s,
                                         'None',
                                         'p:None'])
                                        self.size_s += 1
                                    else:
                                        print 'bat >> brak tid w dvb_t  tid:', tid, ' pomijam serwis sid:', sid

                            if ii[0] == 131:
                                temp_maping[tid] = ii[1]['mappings']

            if self.size_s == 0:
                print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w'
                self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
                self.tmp_str += 'Koniec\n'
                self['memo'].setText(self.tmp_str)
                self.end = 1
                return
            print 'Dodanie numer\xc3\xb3w z maping do serwis\xc3\xb3w'
            for i in self.db_s:
                sid = int(i[1][0:4], 16)
                tid = int(i[1][14:18], 16)
                tidd = temp_maping.get(tid)
                if tidd != None:
                    nr = tidd.get(sid)
                    if nr != None:
                        i[0] = nr
                    else:
                        print 'dvb_s >> brak numeru w maping dla sid:', sid, ' tid:', tid
                else:
                    print 'dvb_s >> brak tid w maping tid:', tid

            print 'Sortowanie'
            self.db_s.sort()
            print 'Transponder\xc3\xb3w:', self.size_t
            print 'Serwis\xc3\xb3w:', self.size_s
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne\n'
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne'
            self.tmp_str += 'Transponder\xc3\xb3w : %d\n' % self.size_t
            self.tmp_str += 'Serwis\xc3\xb3w : %d\n' % self.size_s
            self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - czekaj\n'
            print 'Identyfikacja serwis\xc3\xb3w - czekaj'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P5)
            self.timer.start(100)
            return
            return

    def P5(self):
        self.timer.stop()
        self.timer.callback.remove(self.P5)
        print 'SDT'
        e, sdt, num = getSDT(15, 200)
        print 'SDT:', num
        for n in range(num):
            tid = sdt[n]['transport_stream_id']
            for i in sdt[n]['services']:
                for ii in sdt[n]['services'][i]['descriptors']:
                    if ii[0] == 72:
                        ns = ii[1]['service_name']
                        np = ii[1]['service_provider_name']
                        ss = '%0.4x' % i
                        tt = '%0.4x' % tid
                        pt = find_s_sid_tid(ss, tt, self.db_s)
                        if pt != None:
                            self.db_s[pt][2] = ns
                            self.db_s[pt][3] = 'p:' + np + ',f:1'

        for i in self.db_s:
            if i[2] == 'None':
                print '!!! UWAGA !!! nazwa serwisu pusta >> ', i

        self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P6)
        self.timer.start(100)
        return

    def P6(self):
        self.timer.stop()
        self.timer.callback.remove(self.P6)
        self.lamedb_t = []
        self.lamedb_s = []
        load_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        print 'lamedb - transpondery'
        t_a = 0
        t_u = 0
        for i in self.db_t:
            s = i[0]
            pos = find_t(s, self.lamedb_t)
            if pos != None:
                self.lamedb_t[pos][1] = i[1]
                t_u += 1
            else:
                self.lamedb_t.append([i[0], i[1]])
                t_a += 1

        print 'Zaktualizowano:', t_u
        print 'Dodano:', t_a
        print 'lamedb - serwisy'
        s_a = 0
        s_u = 0
        for i in self.db_s:
            s = i[1]
            pos = find_t(s, self.lamedb_s)
            if pos != None:
                self.lamedb_s[pos][1] = i[2]
                self.lamedb_s[pos][2] = i[3]
                s_u += 1
            else:
                self.lamedb_s.append([i[1], i[2], i[3]])
                s_a += 1

        print 'Zaktualizowano:', s_u
        print 'Dodano:', s_a
        save_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        namet = time.strftime('%d%m%Y_%H%M', time.localtime())
        name1 = 'userbouquet.nc_' + namet + '.tv'
        name2 = 'userbouquet.nc_' + namet + '.radio'
        print 'userbouquet ', name1
        print 'userbouquet ', name2
        f1 = open('/etc/enigma2/' + name1, 'w')
        f2 = open('/etc/enigma2/' + name2, 'w')
        f1.write('#NAME NC+ ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        f2.write('#NAME NC+ ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        build_bouquets(self.db_s, f1, f2)
        f1.close()
        f2.close()
        print 'bouquets.tv'
        f = open('/etc/enigma2/bouquets.tv', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.tv', 'w')
        f.write('#NAME Bouquets (TV)\n')
        f.write('#SERVICE 1:7:1:0:0:0:0:0:0:0:FROM BOUQUET "' + name1 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        print 'bouquets.radio'
        f = open('/etc/enigma2/bouquets.radio', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.radio', 'w')
        f.write('#NAME Bouquets (Radio)\n')
        f.write('#SERVICE 1:7:2:0:0:0:0:0:0:0:FROM BOUQUET "' + name2 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Transponder\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (t_a, t_u)
        self.tmp_str += 'Serwis\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (s_a, s_u)
        self.tmp_str += 'Dodano bukiet:%s\n' % name1
        self.tmp_str += 'Dodano bukiet:%s\n' % name2
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P7)
        self.timer.start(100)
        return

    def P7(self):
        self.timer.stop()
        self.timer.callback.remove(self.P7)
        db = eDVBDB.getInstance()
        db.removeServices(-1, -1, -1, 130)
        if self.zakres == 2:
            db.removeServices(-1, -1, -1, 192)
        db.reloadServicelist()
        db.reloadBouquets()
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone'
        self.tmp_str += '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!\n'
        print '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!'
        self['memo'].setText(self.tmp_str)
        self.end = 1


class Tp(Screen):

    def __init__(self, session, frontend):
        self.frontend = frontend
        self.tuner = Tuner(self.frontend)
        self.tmp_str = ''
        self.old_str = ''
        self.end = 0
        self.skin = '\n\t\t\t<screen position="center,center" size="570,500" title="ORANGE" >\n\t\t\t\t<widget name="memo" position="10,5" size="540,450" font="Regular;20" />\n\t\t\t\t<eLabel position="15,460" size="540,1" backgroundColor="white" />\n\t\t\t\t<widget name="info" position="15,470" size="540,30" halign="center" font="Regular;25" backgroundColor="background" transparent="1"/>\n\t\t\t</screen> '
        Screen.__init__(self, session)
        self['info'] = Label()
        self['info'].setText(i1)
        self['memo'] = Label()
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions'], {'cancel': self.Exit}, -1)
        self.timer = eTimer()
        self.timer.callback.append(self.P1)
        self.timer.start(100)

    def Exit(self):
        if self.end == 1:
            self.close()

    def P1(self):
        self.db_t = []
        self.db_s = []
        self.size_t = 0
        self.size_s = 0
        self.timer.stop()
        self.timer.callback.remove(self.P1)
        transponder = (12284, 27500, 0, 4, 0, 130, 0, 1, 0, 2)
        if self.frontend != None:
            self.tuner.tune(transponder)
            print 'Aktywacja transpondera - czekaj >>', transponder
            self.tmp_str += 'Aktywacja transpondera - czekaj\n'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P2)
            self.timer.start(5000)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak wolnego tunera\n'
            self.tmp_str += 'Koniec\n'
            print 'Aktywacja transpondera - brak wolnego tunera'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        return

    def P2(self):
        self.timer.stop()
        self.timer.callback.remove(self.P2)
        status = {}
        self.frontend.getFrontendStatus(status)
        if status:
            if status.get('tuner_locked') != 1:
                self.tmp_str += 'Aktywacja transpondera - niepoprawna\n'
                self.tmp_str += 'Koniec\n'
                self['memo'].setText(self.tmp_str)
                print 'Aktywacja transpondera - niepoprawna'
                self.end = 1
                return
            self.tmp_str += 'Aktywacja transpondera - poprawna\n'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj\n'
            print 'Aktywacja transpondera poprawna'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P3)
            self.timer.start(100)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak statusu\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            print 'Aktywacja transpondera - brak statusu'
            self.end = 1
            return

    def P3(self):
        self.timer.stop()
        self.timer.callback.remove(self.P3)
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj'
        print 'NIT'
        e, nit, num = getNIT(25, 200)
        print 'NIT:', num
        if num == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        for n in range(num):
            nid = nit[n]['network_id']
            for i in nit[n]['transport_streams']:
                tid = i['transport_stream_id']
                for ii in i['descriptors']:
                    if ii[0] == 67:
                        pos = ii[1]['params']['orbital_position']
                        if pos == 0:
                            print '!!! UWAGA !!! orbital_position=0 tid:', tid, ' ustawiam domyslnie 130'
                            pos = 130
                        l1 = '%0.4x0000:%0.4x:%0.4x' % (pos, tid, nid)
                        if ii[1]['params']['polarization'] == 'V':
                            pol = 1
                        else:
                            pol = 0
                        fec = ii[1]['params']['fec_inner']
                        if fec == 'None':
                            fec = 0
                        elif fec == '1/2':
                            fec = 1
                        elif fec == '2/3':
                            fec = 2
                        elif fec == '3/4':
                            fec = 3
                        elif fec == '5/6':
                            fec = 4
                        elif fec == '7/8':
                            fec = 5
                        elif fec == '8/9':
                            fec = 6
                        elif fec == '3/5':
                            fec = 7
                        elif fec == '4/5':
                            fec = 8
                        elif fec == '9/10':
                            fec = 9
                        else:
                            fec = 0
                        if fec == 0:
                            print '!!! UWAGA !!! fec=0 TID:', tid
                        if ii[1]['params']['modulation_type'] == '8PSK':
                            l2 = 's %s:%s:%s:%s:%s:0:0:1:2:%s:2' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos,
                             ii[1]['params']['rolloff'])
                        else:
                            l2 = 's %s:%s:%s:%s:%s:0:0' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos)
                        self.db_t.append([l1, l2])
                        self.size_t += 1

        if self.size_t == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne\n'
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne'
        self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj\n'
        print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P4)
        self.timer.start(100)

    def P4(self):
        self.timer.stop()
        self.timer.callback.remove(self.P4)
        temp_maping = {}
        print 'BAT'
        e, bat, num = getBAT(15, 200)
        print 'BAT:', num
        if num == 0:
            print 'BAT pusty'
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w'
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        else:
            for n in range(num):
                bid = bat[n]['network_id']
                if bid == 4336:
                    for i in bat[n]['transport_streams']:
                        tid = i['transport_stream_id']
                        for ii in i['descriptors']:
                            if ii[0] == 65:
                                for iii in ii[1]['services']:
                                    s = iii['service_type']
                                    if s == ('digital television service',):
                                        s_t = 1
                                    elif s == ('digital radio sound service',):
                                        s_t = 2
                                    else:
                                        s_t = 3
                                    sid = iii['service_id']
                                    ss = '%0.4x' % tid
                                    pt = find_t_tid(ss, self.db_t)
                                    if pt != None:
                                        s = '%0.4x:%s:%d:0' % (sid, self.db_t[pt][0], s_t)
                                        self.db_s.append([10000,
                                         s,
                                         'None',
                                         'p:None'])
                                        self.size_s += 1
                                    else:
                                        print 'bat >> brak tid w dvb_t  tid:', tid, ' pomijam serwis sid:', sid

                            if ii[0] == 129:
                                temp_maping[tid] = ii[1]['mappings']

            if self.size_s == 0:
                print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w'
                self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
                self.tmp_str += 'Koniec\n'
                self['memo'].setText(self.tmp_str)
                self.end = 1
                return
            print 'Dodanie numer\xc3\xb3w z maping do serwis\xc3\xb3w'
            for i in self.db_s:
                sid = int(i[1][0:4], 16)
                tid = int(i[1][14:18], 16)
                tidd = temp_maping.get(tid)
                if tidd != None:
                    nr = tidd.get(sid)
                    if nr != None:
                        i[0] = nr
                    else:
                        print 'dvb_s >> brak numeru w maping dla sid:', sid, ' tid:', tid
                else:
                    print 'dvb_s >> brak tid w maping tid:', tid

            print 'Sortowanie'
            self.db_s.sort()
            print 'Transponder\xc3\xb3w:', self.size_t
            print 'Serwis\xc3\xb3w:', self.size_s
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne\n'
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne'
            self.tmp_str += 'Transponder\xc3\xb3w : %d\n' % self.size_t
            self.tmp_str += 'Serwis\xc3\xb3w : %d\n' % self.size_s
            self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - czekaj\n'
            print 'Identyfikacja serwis\xc3\xb3w - czekaj'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P5)
            self.timer.start(100)
            return
            return

    def P5(self):
        self.timer.stop()
        self.timer.callback.remove(self.P5)
        print 'SDT'
        e, sdt, num = getSDT(15, 200)
        print 'SDT:', num
        for n in range(num):
            tid = sdt[n]['transport_stream_id']
            for i in sdt[n]['services']:
                for ii in sdt[n]['services'][i]['descriptors']:
                    if ii[0] == 72:
                        ns = ii[1]['service_name'][3:].decode('windows-1250').encode('ascii', 'replace')
                        np = ii[1]['service_provider_name'][3:].decode('windows-1250').encode('ascii', 'replace')
                        ss = '%0.4x' % i
                        tt = '%0.4x' % tid
                        pt = find_s_sid_tid(ss, tt, self.db_s)
                        if pt != None:
                            self.db_s[pt][2] = ns
                            self.db_s[pt][3] = 'p:' + np + ',f:1'

        for i in self.db_s:
            if i[2] == 'None':
                print '!!! UWAGA !!! nazwa serwisu pusta >> ', i

        self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P6)
        self.timer.start(100)
        return

    def P6(self):
        self.timer.stop()
        self.timer.callback.remove(self.P6)
        self.lamedb_t = []
        self.lamedb_s = []
        load_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        print 'lamedb - transpondery'
        t_a = 0
        t_u = 0
        for i in self.db_t:
            s = i[0]
            pos = find_t(s, self.lamedb_t)
            if pos != None:
                self.lamedb_t[pos][1] = i[1]
                t_u += 1
            else:
                self.lamedb_t.append([i[0], i[1]])
                t_a += 1

        print 'Zaktualizowano:', t_u
        print 'Dodano:', t_a
        print 'lamedb - serwisy'
        s_a = 0
        s_u = 0
        for i in self.db_s:
            s = i[1]
            pos = find_t(s, self.lamedb_s)
            if pos != None:
                self.lamedb_s[pos][1] = i[2]
                self.lamedb_s[pos][2] = i[3]
                s_u += 1
            else:
                self.lamedb_s.append([i[1], i[2], i[3]])
                s_a += 1

        print 'Zaktualizowano:', s_u
        print 'Dodano:', s_a
        save_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        namet = time.strftime('%d%m%Y_%H%M', time.localtime())
        name1 = 'userbouquet.orange_' + namet + '.tv'
        name2 = 'userbouquet.orange_' + namet + '.radio'
        print 'userbouquet ', name1
        print 'userbouquet ', name2
        f1 = open('/etc/enigma2/' + name1, 'w')
        f2 = open('/etc/enigma2/' + name2, 'w')
        f1.write('#NAME ORANGE ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        f2.write('#NAME ORANGE ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        build_bouquets(self.db_s, f1, f2)
        f1.close()
        f2.close()
        print 'bouquets.tv'
        f = open('/etc/enigma2/bouquets.tv', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.tv', 'w')
        f.write('#NAME Bouquets (TV)\n')
        f.write('#SERVICE 1:7:1:0:0:0:0:0:0:0:FROM BOUQUET "' + name1 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        print 'bouquets.radio'
        f = open('/etc/enigma2/bouquets.radio', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.radio', 'w')
        f.write('#NAME Bouquets (Radio)\n')
        f.write('#SERVICE 1:7:2:0:0:0:0:0:0:0:FROM BOUQUET "' + name2 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Transponder\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (t_a, t_u)
        self.tmp_str += 'Serwis\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (s_a, s_u)
        self.tmp_str += 'Dodano bukiet:%s\n' % name1
        self.tmp_str += 'Dodano bukiet:%s\n' % name2
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P7)
        self.timer.start(100)
        return

    def P7(self):
        self.timer.stop()
        self.timer.callback.remove(self.P7)
        db = eDVBDB.getInstance()
        db.removeServices(-1, -1, -1, 130)
        db.reloadServicelist()
        db.reloadBouquets()
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone'
        self.tmp_str += '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!\n'
        print '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!'
        self['memo'].setText(self.tmp_str)
        self.end = 1


class Polsat(Screen):

    def __init__(self, session, frontend):
        self.frontend = frontend
        self.tuner = Tuner(self.frontend)
        self.tmp_str = ''
        self.old_str = ''
        self.end = 0
        self.skin = '\n\t\t\t<screen position="center,center" size="570,500" title="POLSAT" >\n\t\t\t\t<widget name="memo" position="10,5" size="540,450" font="Regular;20" />\n\t\t\t\t<eLabel position="15,460" size="540,1" backgroundColor="white" />\n\t\t\t\t<widget name="info" position="15,470" size="540,30" halign="center" font="Regular;25" backgroundColor="background" transparent="1"/>\n\t\t\t</screen> '
        Screen.__init__(self, session)
        self['info'] = Label()
        self['info'].setText(i1)
        self['memo'] = Label()
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions'], {'cancel': self.Exit}, -1)
        self.timer = eTimer()
        self.timer.callback.append(self.P1)
        self.timer.start(100)

    def Exit(self):
        if self.end == 1:
            self.close()

    def P1(self):
        self.db_t = []
        self.db_s = []
        self.size_t = 0
        self.size_s = 0
        self.timer.stop()
        self.timer.callback.remove(self.P1)
        transponder = (11158, 27500, 1, 3, 0, 130, 1, 2, 0, 2)
        if self.frontend != None:
            self.tuner.tune(transponder)
            print 'Aktywacja transpondera - czekaj >>', transponder
            self.tmp_str += 'Aktywacja transpondera - czekaj\n'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P2)
            self.timer.start(5000)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak wolnego tunera\n'
            self.tmp_str += 'Koniec\n'
            print 'Aktywacja transpondera - brak wolnego tunera'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        return

    def P2(self):
        self.timer.stop()
        self.timer.callback.remove(self.P2)
        status = {}
        self.frontend.getFrontendStatus(status)
        if status:
            if status.get('tuner_locked') != 1:
                self.tmp_str += 'Aktywacja transpondera - niepoprawna\n'
                self.tmp_str += 'Koniec\n'
                self['memo'].setText(self.tmp_str)
                print 'Aktywacja transpondera - niepoprawna'
                self.end = 1
                return
            self.tmp_str += 'Aktywacja transpondera - poprawna\n'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj\n'
            print 'Aktywacja transpondera poprawna'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P3)
            self.timer.start(100)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak statusu\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            print 'Aktywacja transpondera - brak statusu'
            self.end = 1
            return

    def P3(self):
        self.timer.stop()
        self.timer.callback.remove(self.P3)
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj'
        print 'NIT'
        e, self.nit, self.num = getNIT(15, 200)
        print 'NIT:', self.num
        if self.num == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        for n in range(self.num):
            nid = self.nit[n]['network_id']
            for i in self.nit[n]['transport_streams']:
                tid = i['transport_stream_id']
                for ii in i['descriptors']:
                    if ii[0] == 67:
                        pos = ii[1]['params']['orbital_position']
                        if pos == 0:
                            print '!!! UWAGA !!! orbital_position=0 tid:', tid, ' ustawiam domyslnie 130'
                            pos = 130
                        l1 = '%0.4x0000:%0.4x:%0.4x' % (pos, tid, nid)
                        if ii[1]['params']['polarization'] == 'V':
                            pol = 1
                        else:
                            pol = 0
                        fec = ii[1]['params']['fec_inner']
                        if fec == 'None':
                            fec = 0
                        elif fec == '1/2':
                            fec = 1
                        elif fec == '2/3':
                            fec = 2
                        elif fec == '3/4':
                            fec = 3
                        elif fec == '5/6':
                            fec = 4
                        elif fec == '7/8':
                            fec = 5
                        elif fec == '8/9':
                            fec = 6
                        elif fec == '3/5':
                            fec = 7
                        elif fec == '4/5':
                            fec = 8
                        elif fec == '9/10':
                            fec = 9
                        else:
                            fec = 0
                        if fec == 0:
                            print '!!! UWAGA !!! fec=0 TID:', tid
                        if ii[1]['params']['modulation_type'] == '8PSK':
                            l2 = 's %s:%s:%s:%s:%s:0:0:1:2:%s:2' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos,
                             ii[1]['params']['rolloff'])
                        else:
                            l2 = 's %s:%s:%s:%s:%s:0:0' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos)
                        self.db_t.append([l1, l2])
                        self.size_t += 1

        if self.size_t == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne\n'
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne'
        self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj\n'
        print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P4)
        self.timer.start(100)

    def P4(self):
        self.timer.stop()
        self.timer.callback.remove(self.P4)
        temp_maping = {}
        for n in range(self.num):
            nid = self.nit[n]['network_id']
            for i in self.nit[n]['transport_streams']:
                tid = i['transport_stream_id']
                for ii in i['descriptors']:
                    if ii[0] == 65:
                        for iii in ii[1]['services']:
                            s = iii['service_type']
                            if s == ('digital television service',):
                                s_t = 1
                            elif s == ('digital radio sound service',):
                                s_t = 2
                            else:
                                s_t = 3
                            sid = iii['service_id']
                            ss = '%0.4x' % tid
                            pt = find_t_tid(ss, self.db_t)
                            if pt != None:
                                s = '%0.4x:%s:%d:0' % (sid, self.db_t[pt][0], s_t)
                                self.db_s.append([10000,
                                 s,
                                 'None',
                                 'p:None'])
                                self.size_s += 1
                            else:
                                print 'brak tid w dvb_t  tid:', tid, ' pomijam serwis sid:', sid

                    if ii[0] == 130:
                        temp_maping[tid] = ii[1]['mappings']

        if self.size_s == 0:
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w'
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        else:
            print 'Dodawanie numer\xc3\xb3w z maping do serwis\xc3\xb3w'
            for i in self.db_s:
                sid = int(i[1][0:4], 16)
                tid = int(i[1][14:18], 16)
                tidd = temp_maping.get(tid)
                if tidd != None:
                    nr = tidd.get(sid)
                    if nr != None:
                        i[0] = nr
                    else:
                        print 'dvb_s >> brak numeru w maping dla sid:', sid, ' tid:', tid
                else:
                    print 'dvb_s >> brak tid w maping tid:', tid

            print 'Sortowanie'
            self.db_s.sort()
            print 'Transponder\xc3\xb3w:', self.size_t
            print 'Serwis\xc3\xb3w:', self.size_s
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne\n'
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne'
            self.tmp_str += 'Transponder\xc3\xb3w : %d\n' % self.size_t
            self.tmp_str += 'Serwis\xc3\xb3w : %d\n' % self.size_s
            self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - czekaj\n'
            print 'Identyfikacja serwis\xc3\xb3w - czekaj'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P5)
            self.timer.start(100)
            return
            return

    def P5(self):
        self.timer.stop()
        self.timer.callback.remove(self.P5)
        print 'SDT'
        e, sdt, num = getSDT(15, 200)
        print 'SDT:', num
        for n in range(num):
            tid = sdt[n]['transport_stream_id']
            for i in sdt[n]['services']:
                for ii in sdt[n]['services'][i]['descriptors']:
                    if ii[0] == 72:
                        ns = ii[1]['service_name']
                        np = ii[1]['service_provider_name']
                        ss = '%0.4x' % i
                        tt = '%0.4x' % tid
                        pt = find_s_sid_tid(ss, tt, self.db_s)
                        if pt != None:
                            self.db_s[pt][2] = ns
                            self.db_s[pt][3] = 'p:' + np + ',f:1'

        for i in self.db_s:
            if i[2] == 'None':
                print '!!! UWAGA !!! nazwa serwisu pusta ', i

        self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P6)
        self.timer.start(100)
        return

    def P6(self):
        self.timer.stop()
        self.timer.callback.remove(self.P6)
        self.lamedb_t = []
        self.lamedb_s = []
        load_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        print 'lamedb - transpondery'
        t_a = 0
        t_u = 0
        for i in self.db_t:
            s = i[0]
            pos = find_t(s, self.lamedb_t)
            if pos != None:
                self.lamedb_t[pos][1] = i[1]
                t_u += 1
            else:
                self.lamedb_t.append([i[0], i[1]])
                t_a += 1

        print 'Zaktualizowano:', t_u
        print 'Dodano:', t_a
        print 'lamedb - serwisy'
        s_a = 0
        s_u = 0
        for i in self.db_s:
            s = i[1]
            pos = find_t(s, self.lamedb_s)
            if pos != None:
                self.lamedb_s[pos][1] = i[2]
                self.lamedb_s[pos][2] = i[3]
                s_u += 1
            else:
                self.lamedb_s.append([i[1], i[2], i[3]])
                s_a += 1

        print 'Zaktualizowano:', s_u
        print 'Dodano:', s_a
        save_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        namet = time.strftime('%d%m%Y_%H%M', time.localtime())
        name1 = 'userbouquet.polsat_' + namet + '.tv'
        name2 = 'userbouquet.polsat_' + namet + '.radio'
        print 'userbouquet ', name1
        print 'userbouquet ', name2
        f1 = open('/etc/enigma2/' + name1, 'w')
        f2 = open('/etc/enigma2/' + name2, 'w')
        f1.write('#NAME POLSAT ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        f2.write('#NAME POLSAT ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        build_bouquets(self.db_s, f1, f2)
        f1.close()
        f2.close()
        print 'bouquets.tv'
        f = open('/etc/enigma2/bouquets.tv', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.tv', 'w')
        f.write('#NAME Bouquets (TV)\n')
        f.write('#SERVICE 1:7:1:0:0:0:0:0:0:0:FROM BOUQUET "' + name1 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        print 'bouquets.radio'
        f = open('/etc/enigma2/bouquets.radio', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.radio', 'w')
        f.write('#NAME Bouquets (Radio)\n')
        f.write('#SERVICE 1:7:2:0:0:0:0:0:0:0:FROM BOUQUET "' + name2 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Transponder\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (t_a, t_u)
        self.tmp_str += 'Serwis\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (s_a, s_u)
        self.tmp_str += 'Dodano bukiet:%s\n' % name1
        self.tmp_str += 'Dodano bukiet:%s\n' % name2
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P7)
        self.timer.start(100)
        return

    def P7(self):
        self.timer.stop()
        self.timer.callback.remove(self.P7)
        db = eDVBDB.getInstance()
        db.removeServices(-1, -1, -1, 130)
        db.reloadServicelist()
        db.reloadBouquets()
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone'
        self.tmp_str += '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!\n'
        print '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!\n'
        self['memo'].setText(self.tmp_str)
        self.end = 1


class Tnkhd(Screen):

    def __init__(self, session, frontend):
        self.frontend = frontend
        self.tuner = Tuner(self.frontend)
        self.tmp_str = ''
        self.old_str = ''
        self.end = 0
        self.skin = '\n\t\t\t<screen position="center,center" size="570,500" title="TNK HD" >\n\t\t\t\t<widget name="memo" position="10,5" size="540,450" font="Regular;20" />\n\t\t\t\t<eLabel position="15,460" size="540,1" backgroundColor="white" />\n\t\t\t\t<widget name="info" position="15,470" size="540,30" halign="center" font="Regular;25" backgroundColor="background" transparent="1"/>\n\t\t\t</screen> '
        Screen.__init__(self, session)
        self['info'] = Label()
        self['info'].setText(i1)
        self['memo'] = Label()
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions'], {'cancel': self.Exit}, -1)
        self.timer = eTimer()
        self.timer.callback.append(self.P1)
        self.timer.start(100)

    def Exit(self):
        if self.end == 1:
            self.close()

    def P1(self):
        self.db_t = []
        self.db_s = []
        self.size_t = 0
        self.size_s = 0
        self.timer.stop()
        self.timer.callback.remove(self.P1)
        transponder = (11449, 27500, 0, 2, 2, 130, 1, 2, 0, 2)
        if self.frontend != None:
            self.tuner.tune(transponder)
            print 'Aktywacja transpondera - czekaj >>', transponder
            self.tmp_str += 'Aktywacja transpondera - czekaj\n'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P2)
            self.timer.start(5000)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak wolnego tunera\n'
            self.tmp_str += 'Koniec\n'
            print 'Aktywacja transpondera - brak wolnego tunera'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        return

    def P2(self):
        self.timer.stop()
        self.timer.callback.remove(self.P2)
        status = {}
        self.frontend.getFrontendStatus(status)
        if status:
            if status.get('tuner_locked') != 1:
                self.tmp_str += 'Aktywacja transpondera - niepoprawna\n'
                self.tmp_str += 'Koniec\n'
                self['memo'].setText(self.tmp_str)
                print 'Aktywacja transpondera - niepoprawna'
                self.end = 1
                return
            self.tmp_str += 'Aktywacja transpondera - poprawna\n'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj\n'
            print 'Aktywacja transpondera poprawna'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P3)
            self.timer.start(100)
        else:
            self.tmp_str += 'Aktywacja transpondera - brak statusu\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            print 'Aktywacja transpondera - brak statusu'
            self.end = 1
            return

    def P3(self):
        self.timer.stop()
        self.timer.callback.remove(self.P3)
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - czekaj'
        print 'NIT'
        e, self.nit, self.num = getNIT(30, 200)
        print 'NIT:', self.num
        if self.num == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak listy\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        for n in range(self.num):
            nid = self.nit[n]['network_id']
            for i in self.nit[n]['transport_streams']:
                tid = i['transport_stream_id']
                for ii in i['descriptors']:
                    if ii[0] == 67:
                        pos = ii[1]['params']['orbital_position']
                        if pos == 0:
                            print '!!! UWAGA !!! orbital_position=0 tid:', tid, ' ustawiam domyslnie 130'
                            pos = 130
                        l1 = '%0.4x0000:%0.4x:%0.4x' % (pos, tid, nid)
                        if ii[1]['params']['polarization'] == 'V':
                            pol = 1
                        else:
                            pol = 0
                        fec = ii[1]['params']['fec_inner']
                        if fec == 'None':
                            fec = 0
                        elif fec == '1/2':
                            fec = 1
                        elif fec == '2/3':
                            fec = 2
                        elif fec == '3/4':
                            fec = 3
                        elif fec == '5/6':
                            fec = 4
                        elif fec == '7/8':
                            fec = 5
                        elif fec == '8/9':
                            fec = 6
                        elif fec == '3/5':
                            fec = 7
                        elif fec == '4/5':
                            fec = 8
                        elif fec == '9/10':
                            fec = 9
                        else:
                            fec = 0
                        if fec == 0:
                            print '!!! UWAGA !!! fec=0 TID:', tid
                        if ii[1]['params']['modulation_type'] == '8PSK':
                            l2 = 's %s:%s:%s:%s:%s:0:0:1:2:%s:2' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos,
                             ii[1]['params']['rolloff'])
                        else:
                            l2 = 's %s:%s:%s:%s:%s:0:0' % (ii[1]['params']['frequency'],
                             ii[1]['params']['symbol_rate'],
                             pol,
                             fec,
                             pos)
                        self.db_t.append([l1, l2])
                        self.size_t += 1

        if self.size_t == 0:
            print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w\n'
            self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - brak transponder\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        self.tmp_str += 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne\n'
        print 'Odbieram list\xc4\x99 transponder\xc3\xb3w - dane poprawne\n'
        self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj\n'
        print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - czekaj\n'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P4)
        self.timer.start(100)

    def P4(self):
        self.timer.stop()
        self.timer.callback.remove(self.P4)
        temp_maping = {}
        for n in range(self.num):
            nid = self.nit[n]['network_id']
            for i in self.nit[n]['transport_streams']:
                tid = i['transport_stream_id']
                for ii in i['descriptors']:
                    if ii[0] == 65:
                        for iii in ii[1]['services']:
                            s = iii['service_type']
                            if s == ('digital television service',):
                                s_t = 1
                            elif s == ('digital radio sound service',):
                                s_t = 2
                            else:
                                s_t = 3
                            sid = iii['service_id']
                            ss = '%0.4x' % tid
                            pt = find_t_tid(ss, self.db_t)
                            if pt != None:
                                s = '%0.4x:%s:%d:0' % (sid, self.db_t[pt][0], s_t)
                                self.db_s.append([10000,
                                 s,
                                 'None',
                                 'p:None'])
                                self.size_s += 1
                            else:
                                print 'brak tid w dvb_t  tid:', tid, ' pomijam serwis sid:', sid

                    if ii[0] == 131:
                        temp_maping[tid] = ii[1]['mappings']

        if self.size_s == 0:
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - brak serwis\xc3\xb3w\n'
            self.tmp_str += 'Koniec\n'
            self['memo'].setText(self.tmp_str)
            self.end = 1
            return
        else:
            print 'Dodawanie numer\xc3\xb3w z maping dla serwis\xc3\xb3w'
            for i in self.db_s:
                sid = int(i[1][0:4], 16)
                tid = int(i[1][14:18], 16)
                tidd = temp_maping.get(tid)
                if tidd != None:
                    nr = tidd.get(sid)
                    if nr != None:
                        i[0] = nr
                    else:
                        print 'dvb_s >> brak numeru w maping dla sid:', sid, ' tid:', tid
                else:
                    print 'dvb_s >> brak tid w maping tid:', tid

            print 'Sortowanie'
            self.db_s.sort()
            print 'Transponder\xc3\xb3w:', self.size_t
            print 'Serwis\xc3\xb3w:', self.size_s
            self.tmp_str += 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne\n'
            print 'Odbieram list\xc4\x99 serwis\xc3\xb3w - dane poprawne'
            self.tmp_str += 'Transponder\xc3\xb3w : %d\n' % self.size_t
            self.tmp_str += 'Serwis\xc3\xb3w : %d\n' % self.size_s
            self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - czekaj\n'
            print 'Identyfikacja serwis\xc3\xb3w - czekaj'
            self['memo'].setText(self.tmp_str)
            self.timer.callback.append(self.P5)
            self.timer.start(100)
            return
            return

    def P5(self):
        self.timer.stop()
        self.timer.callback.remove(self.P5)
        print 'SDT'
        e, sdt, num = getSDT(15, 200)
        print 'SDT:', num
        for n in range(num):
            tid = sdt[n]['transport_stream_id']
            for i in sdt[n]['services']:
                for ii in sdt[n]['services'][i]['descriptors']:
                    if ii[0] == 72:
                        ns = ii[1]['service_name']
                        np = ii[1]['service_provider_name']
                        ss = '%0.4x' % i
                        tt = '%0.4x' % tid
                        pt = find_s_sid_tid(ss, tt, self.db_s)
                        if pt != None:
                            self.db_s[pt][2] = ns
                            self.db_s[pt][3] = 'p:' + np + ',f:1'

        for i in self.db_s:
            if i[2] == 'None':
                print '!!! UWAGA !!! nazwa serwisu pusta ', i

        self.tmp_str += 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Identyfikacja serwis\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P6)
        self.timer.start(100)
        return

    def P6(self):
        self.timer.stop()
        self.timer.callback.remove(self.P6)
        self.lamedb_t = []
        self.lamedb_s = []
        load_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        print 'lamedb - transpondery'
        t_a = 0
        t_u = 0
        for i in self.db_t:
            s = i[0]
            pos = find_t(s, self.lamedb_t)
            if pos != None:
                self.lamedb_t[pos][1] = i[1]
                t_u += 1
            else:
                self.lamedb_t.append([i[0], i[1]])
                t_a += 1

        print 'Zaktualizowano:', t_u
        print 'Dodano:', t_a
        print 'lamedb - serwisy'
        s_a = 0
        s_u = 0
        for i in self.db_s:
            s = i[1]
            pos = find_t(s, self.lamedb_s)
            if pos != None:
                self.lamedb_s[pos][1] = i[2]
                self.lamedb_s[pos][2] = i[3]
                s_u += 1
            else:
                self.lamedb_s.append([i[1], i[2], i[3]])
                s_a += 1

        print 'Zaktualizowano:', s_u
        print 'Dodano:', s_a
        save_lamedb('/etc/enigma2/lamedb', self.lamedb_t, self.lamedb_s)
        namet = time.strftime('%d%m%Y_%H%M', time.localtime())
        name1 = 'userbouquet.tnkhd_' + namet + '.tv'
        name2 = 'userbouquet.tnkhd_' + namet + '.radio'
        print 'userbouquet ', name1
        print 'userbouquet ', name2
        f1 = open('/etc/enigma2/' + name1, 'w')
        f2 = open('/etc/enigma2/' + name2, 'w')
        f1.write('#NAME TNK HD ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        f2.write('#NAME TNK HD ' + namet[0:8] + ' ' + namet[9:13] + '\n')
        build_bouquets(self.db_s, f1, f2)
        f1.close()
        f2.close()
        print 'bouquets.tv'
        f = open('/etc/enigma2/bouquets.tv', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.tv', 'w')
        f.write('#NAME Bouquets (TV)\n')
        f.write('#SERVICE 1:7:1:0:0:0:0:0:0:0:FROM BOUQUET "' + name1 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        print 'bouquets.radio'
        f = open('/etc/enigma2/bouquets.radio', 'r')
        buf = f.readlines()
        f.close()
        buf.pop(0)
        f = open('/etc/enigma2/bouquets.radio', 'w')
        f.write('#NAME Bouquets (Radio)\n')
        f.write('#SERVICE 1:7:2:0:0:0:0:0:0:0:FROM BOUQUET "' + name2 + '" ORDER BY bouquet\n')
        for i in buf:
            f.write(i)

        f.close()
        self.tmp_str += 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona\n'
        print 'Aktualizacja listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czona'
        self.tmp_str += 'Transponder\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (t_a, t_u)
        self.tmp_str += 'Serwis\xc3\xb3w dodano:%d zaktualizowano:%d\n' % (s_a, s_u)
        self.tmp_str += 'Dodano bukiet:%s\n' % name1
        self.tmp_str += 'Dodano bukiet:%s\n' % name2
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - czekaj'
        self['memo'].setText(self.tmp_str)
        self.timer.callback.append(self.P7)
        self.timer.start(100)
        return

    def P7(self):
        self.timer.stop()
        self.timer.callback.remove(self.P7)
        db = eDVBDB.getInstance()
        db.removeServices(-1, -1, -1, 130)
        db.reloadServicelist()
        db.reloadBouquets()
        self.tmp_str += '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone\n'
        print '\xc5\x81adowanie nowej listy kana\xc5\x82\xc3\xb3w - zako\xc5\x84czone'
        self.tmp_str += '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!\n'
        print '!!! Szybkie wyszukiwanie zako\xc5\x84czone poprawnie !!!'
        self['memo'].setText(self.tmp_str)
        self.end = 1


class FastSearchStart(Screen):

    def openFrontend(self):
        res_mgr = eDVBResourceManager.getInstance()
        if res_mgr:
            self.raw_channel = res_mgr.allocateRawChannel(self.feid)
            if self.raw_channel:
                self.frontend = self.raw_channel.getFrontend()
                if self.frontend:
                    return True
                print 'getFrontend failed'
            else:
                print 'getRawChannel failed'
        else:
            print 'getResourceManager instance failed'
        return False

    def __init__(self, session):
        global first_service
        first_service = None
        self.session = session
        self.feid = 0
        self.oldref = None
        self.getfrontend = False
        self.skin = '\n\t\t\t<screen position="center,center" size="570,420" title="Szybkie wyszukiwanie">\n\t\t\t\t<ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" alphatest="on" />\n\t\t\t\t<ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" alphatest="on" />\n\t\t\t\t<ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" size="140,40" alphatest="on" />\n\t\t\t\t<ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" size="140,40" alphatest="on" />\n\t\t\t\t<widget source="red" render="Label" position="0,0" zPosition="1" size="140,40" font="Regular;20" halign="center" valign="center" backgroundColor="#9f1313" transparent="1" />\n\t\t\t\t<widget source="green" render="Label" position="140,0" zPosition="1" size="140,40" font="Regular;20" halign="center" valign="center" backgroundColor="#1f771f" transparent="1" />\n\t\t\t\t<widget source="yellow" render="Label" position="280,0" zPosition="1" size="140,40" font="Regular;20" halign="center" valign="center" backgroundColor="#a08500" transparent="1" />\n\t\t\t\t<widget source="blue" render="Label" position="420,0" zPosition="1" size="140,40" font="Regular;20" halign="center" valign="center" backgroundColor="#18188b" transparent="1" />\n\t\t\t\t<widget name="myMenu" position="10,50" size="540,300" scrollbarMode="showOnDemand" />\n\t\t\t\t<eLabel position="15,380" size="540,1" backgroundColor="white" />\n\t\t\t\t<widget name="info" position="15,390" size="540,30" halign="center" font="Regular;25" backgroundColor="background" transparent="1"/>\n\t\t\t</screen> '
        Screen.__init__(self, session)
        self['info'] = Label()
        self['red'] = StaticText('Start')
        self['green'] = StaticText('Numeracja')
        self['yellow'] = StaticText('')
        self['blue'] = StaticText('O pluginie')
        self['info'].setText(i1)
        lista = []
        lista.append(('NC+ HotBird', '1'))
        lista.append(('NC+ HotBird+Astra', '2'))
        lista.append(('POLSAT', '3'))
        self['myMenu'] = MenuList(lista)
        self['actions'] = ActionMap(['OkCancelActions', 'ColorActions'], {'ok': self.Ok,
         'cancel': self.Exit,
         'red': self.red,
         'green': self.green,
         'yellow': self.yellow,
         'blue': self.blue}, -1)
        self.onClose.append(self.__onClose)
        return

    def __onClose(self):
        print '[FS] END'
        if self.getfrontend == True:
            if self.frontend:
                self.frontend = None
                del self.raw_channel
        return

    def Ok(self):
        print '[FS] OK'

    def red(self):
        global first_service
        print '[FS] RED'
        if self.getfrontend == False:
            if not self.openFrontend():
                self.oldref = self.session.nav.getCurrentlyPlayingServiceReference()
                self.session.nav.stopService()
                if not self.openFrontend():
                    if self.session.pipshown:
                        self.session.pipshown = False
                        del self.session.pip
                        if not self.openFrontend():
                            self.frontend = None
        self.getfrontend = True
        first_service = None
        pozycja = self['myMenu'].l.getCurrentSelection()[1]
        print '[MyMenu] : ' + pozycja + '\n'
        if pozycja == '1':
            self.session.open(Cyfra, self.frontend, 1)
        if pozycja == '2':
            self.session.open(Cyfra, self.frontend, 2)
        if pozycja == '3':
            self.session.open(Polsat, self.frontend)
        return

    def green(self):
        print '[FS] GREEN'
        self.session.openWithCallback(set_order, MessageBox, 'Numeracja operatora?', type=MessageBox.TYPE_YESNO, default=oper_order)

    def yellow(self):
        print '[FS] YELLOW'

    def blue(self):
        print '[FS] BLUE'
        self.session.open(MessageBox, i1 + '\n\n' + i2, MessageBox.TYPE_INFO)

    def Exit(self):
        self.close()
# okay decompyling FastSearch.pyo 
# decompiled 1 files: 1 okay, 0 failed, 0 verify failed
# 2016.11.08 20:41:58 CET
